#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAXN = 1 << 18;

int n, m, q;

unordered_map<int, int> t[MAXN], ot[MAXN];

int get(unordered_map<int, int> &mp, int x) {
    if (mp.count(x)) return mp[x];
    return x;
}

void upd(int v, int tl, int tr, int x, int &a, int &A, int &b, int &B) {
    if (tl == tr) {
        A = get(t[v], b);
        B = get(t[v], a);
        t[v][a] = A;
        t[v][b] = B;
        ot[v][A] = a;
        ot[v][B] = b;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (x <= tm) {
        upd(v * 2, tl, tm, x, a, A, b, B);
        A = get(t[v * 2 + 1], A);
        B = get(t[v * 2 + 1], B);
    } else {
        upd(v * 2 + 1, tm + 1, tr, x, a, A, b, B);
        a = get(ot[v * 2], a);
        b = get(ot[v * 2], b);
    }
    t[v][a] = A;
    t[v][b] = B;
    ot[v][A] = a;
    ot[v][B] = b;
}

int get(int v, int tl, int tr, int l, int r, int id) {
    if (l > r) return id;
    if (l == tl && r == tr) return get(t[v], id);
    int tm = (tl + tr) >> 1;
    return get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, get(v * 2, tl, tm, l, min(r, tm), id));
}

int main() {
    freopen("conveyor.in", "r", stdin);
    freopen("conveyor.out", "w", stdout);

    scanf("%d%d%d", &n, &m, &q);
    for (int ii = 0; ii < q; ii++) {
        int t;
        scanf("%d", &t);
        if (t == 0) {
            int a, b, x;
            scanf("%d%d%d", &a, &b, &x);
            --a; --b; --x;
            int A, B;
            upd(1, 0, m - 1, x, a, A, b, B);
        }
        if (t == 1) {
            int r, x;
            scanf("%d%d", &r, &x);
            --r; --x;
            printf("%d\n", get(1, 0, m - 1, 0, x, r) + 1);
        }
    }

    return 0;
}
