#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
//#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h> 
#include <list>
#include <cstring>
#include <queue>
using namespace std;

#define name "conveyor"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair


struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-8;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 1e5 + 7;

struct perm{
	map<int, int> Go, Inv;
	int get(int v){
		if(Go.count(v)){
			return Go[v];
		}
		return v;
	}
	int unGet(int v){
		if(Inv.count(v)){
			return Inv[v];
		}
		return v;
	}
	void swapPr(int a, int b){
		if(!Go.count(a)){
			Go[a] = a;
			Inv[a] = a;
		}
		if(!Go.count(b)){
			Inv[b] = b;
			Go[b] = b;
		}
		swap(Go[a], Go[b]);
		swap(Inv[a], Inv[b]);
	}
	void add(int v, int to){
		Go[v] = to;
		Inv[to] = v;
	}
	void del(int v){
		Inv.erase(Go[v]);
		Go.erase(v);
	}
};

perm P[dd * 4];

vector<int> Qu;

void get(int v, int l, int r, int lq, int rq){
	if(lq > rq){
		return;
	}
	if(lq == l && rq == r){
		Qu.push_back(v);
		return;
	}
	int s = (l + r) / 2;
	get(v * 2, l, s, lq, min(rq, s));
	get(v * 2 + 1, s + 1, r, max(lq, s + 1), rq);
}

pair<pair<int, int>, pair<int, int> > upd(int v, int l, int r, int x, int a, int b){

	if(l == r){
		P[v].swapPr(a, b);
		return mk(mk(a, P[v].get(a)), mk(b, P[v].get(b)));
	}
	int s = (l + r) / 2;
	if(x <= s){
		auto t = upd(v * 2, l, s, x, a, b);
		int toA = P[v * 2 + 1].get(t.first.second);
		int toB = P[v * 2 + 1].get(t.second.second);
		P[v].del(t.first.first);
		P[v].del(t.second.first);
		P[v].add(t.first.first, toA);
		P[v].add(t.second.first, toB);
		return mk(mk(t.first.first, toA), mk(t.second.first, toB));
	}
	else{
		auto t = upd(v * 2 + 1, s + 1, r, x, a, b);
		int toA = P[v * 2].unGet(t.first.first);
		int toB = P[v * 2].unGet(t.second.first);
		P[v].del(toA);
		P[v].del(toB);
		P[v].add(toA, t.first.second);
		P[v].add(toB, t.second.second);
		return mk(mk(toA, t.first.second), mk(toB, t.second.second));
	}
}

int n, m;

int get(int r, int t){
	Qu.clear();
	get(1, 0, m - 1, 0, r);
	for(int i = 0; i < Qu.size(); i++){
		t = P[Qu[i]].get(t);
	}
	return t;
}

void upd(int a, int b, int x){
	upd(1, 0, m - 1, x, a, b);
}

int main() {
    int q;
	cin >> n >> m >> q;
	for(int i = 0; i < q; i++){
		int t, l, r, x;
		scanf("%d", &t);
		if(t == 0){
			scanf("%d%d%d", &l, &r, &x);
			upd(l, r, x - 1);
		}
		else{
		    int a, b;
			scanf("%d%d", &a, &b);
			int t = get(b - 1, a);
			printf("%d\n", t);
		}
	}
}